# coding: utf-8

"""
    Python SDK for Logto API

    Python SDK for Logto API.  Note: This SDK is for Logto Cloud and OSS. However, if you are using Logto OSS, some features available in the SDK may not work for you. Please refer to the response of `/api/swagger.json` endpoint on your Logto OSS instance for features available to you.

    The version of the OpenAPI document: 1.22.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from py_logto.models.api_interaction_bind_mfa_post_request_one_of import ApiInteractionBindMfaPostRequestOneOf
from py_logto.models.api_interaction_bind_mfa_post_request_one_of1 import ApiInteractionBindMfaPostRequestOneOf1
from py_logto.models.api_interaction_bind_mfa_post_request_one_of2 import ApiInteractionBindMfaPostRequestOneOf2
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

APIINTERACTIONBINDMFAPOSTREQUEST_ONE_OF_SCHEMAS = ["ApiInteractionBindMfaPostRequestOneOf", "ApiInteractionBindMfaPostRequestOneOf1", "ApiInteractionBindMfaPostRequestOneOf2"]

class ApiInteractionBindMfaPostRequest(BaseModel):
    """
    ApiInteractionBindMfaPostRequest
    """
    # data type: ApiInteractionBindMfaPostRequestOneOf
    oneof_schema_1_validator: Optional[ApiInteractionBindMfaPostRequestOneOf] = None
    # data type: ApiInteractionBindMfaPostRequestOneOf1
    oneof_schema_2_validator: Optional[ApiInteractionBindMfaPostRequestOneOf1] = None
    # data type: ApiInteractionBindMfaPostRequestOneOf2
    oneof_schema_3_validator: Optional[ApiInteractionBindMfaPostRequestOneOf2] = None
    actual_instance: Optional[Union[ApiInteractionBindMfaPostRequestOneOf, ApiInteractionBindMfaPostRequestOneOf1, ApiInteractionBindMfaPostRequestOneOf2]] = None
    one_of_schemas: Set[str] = { "ApiInteractionBindMfaPostRequestOneOf", "ApiInteractionBindMfaPostRequestOneOf1", "ApiInteractionBindMfaPostRequestOneOf2" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ApiInteractionBindMfaPostRequest.model_construct()
        error_messages = []
        match = 0
        # validate data type: ApiInteractionBindMfaPostRequestOneOf
        if not isinstance(v, ApiInteractionBindMfaPostRequestOneOf):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ApiInteractionBindMfaPostRequestOneOf`")
        else:
            match += 1
        # validate data type: ApiInteractionBindMfaPostRequestOneOf1
        if not isinstance(v, ApiInteractionBindMfaPostRequestOneOf1):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ApiInteractionBindMfaPostRequestOneOf1`")
        else:
            match += 1
        # validate data type: ApiInteractionBindMfaPostRequestOneOf2
        if not isinstance(v, ApiInteractionBindMfaPostRequestOneOf2):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ApiInteractionBindMfaPostRequestOneOf2`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ApiInteractionBindMfaPostRequest with oneOf schemas: ApiInteractionBindMfaPostRequestOneOf, ApiInteractionBindMfaPostRequestOneOf1, ApiInteractionBindMfaPostRequestOneOf2. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ApiInteractionBindMfaPostRequest with oneOf schemas: ApiInteractionBindMfaPostRequestOneOf, ApiInteractionBindMfaPostRequestOneOf1, ApiInteractionBindMfaPostRequestOneOf2. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into ApiInteractionBindMfaPostRequestOneOf
        try:
            instance.actual_instance = ApiInteractionBindMfaPostRequestOneOf.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ApiInteractionBindMfaPostRequestOneOf1
        try:
            instance.actual_instance = ApiInteractionBindMfaPostRequestOneOf1.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ApiInteractionBindMfaPostRequestOneOf2
        try:
            instance.actual_instance = ApiInteractionBindMfaPostRequestOneOf2.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ApiInteractionBindMfaPostRequest with oneOf schemas: ApiInteractionBindMfaPostRequestOneOf, ApiInteractionBindMfaPostRequestOneOf1, ApiInteractionBindMfaPostRequestOneOf2. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ApiInteractionBindMfaPostRequest with oneOf schemas: ApiInteractionBindMfaPostRequestOneOf, ApiInteractionBindMfaPostRequestOneOf1, ApiInteractionBindMfaPostRequestOneOf2. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ApiInteractionBindMfaPostRequestOneOf, ApiInteractionBindMfaPostRequestOneOf1, ApiInteractionBindMfaPostRequestOneOf2]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


