# coding: utf-8

"""
    Python SDK for Logto API

    Python SDK for Logto API.  Note: This SDK is for Logto Cloud and OSS. However, if you are using Logto OSS, some features available in the SDK may not work for you. Please refer to the response of `/api/swagger.json` endpoint on your Logto OSS instance for features available to you.

    The version of the OpenAPI document: 1.22.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from py_logto.models.create_web_authn_registration_verification200_response_registration_options_exclude_credentials_inner import CreateWebAuthnRegistrationVerification200ResponseRegistrationOptionsExcludeCredentialsInner
from py_logto.models.create_web_authn_registration_verification200_response_registration_options_extensions import CreateWebAuthnRegistrationVerification200ResponseRegistrationOptionsExtensions
from typing import Optional, Set
from typing_extensions import Self

class CreateWebAuthnAuthenticationVerification200ResponseAuthenticationOptions(BaseModel):
    """
    Options for the user to authenticate with their WebAuthn credential.
    """ # noqa: E501
    challenge: StrictStr
    timeout: Optional[Union[StrictFloat, StrictInt]] = None
    rp_id: Optional[StrictStr] = Field(default=None, alias="rpId")
    allow_credentials: Optional[List[CreateWebAuthnRegistrationVerification200ResponseRegistrationOptionsExcludeCredentialsInner]] = Field(default=None, alias="allowCredentials")
    user_verification: Optional[StrictStr] = Field(default=None, alias="userVerification")
    extensions: Optional[CreateWebAuthnRegistrationVerification200ResponseRegistrationOptionsExtensions] = None
    __properties: ClassVar[List[str]] = ["challenge", "timeout", "rpId", "allowCredentials", "userVerification", "extensions"]

    @field_validator('user_verification')
    def user_verification_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['required', 'preferred', 'discouraged']):
            raise ValueError("must be one of enum values ('required', 'preferred', 'discouraged')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateWebAuthnAuthenticationVerification200ResponseAuthenticationOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in allow_credentials (list)
        _items = []
        if self.allow_credentials:
            for _item_allow_credentials in self.allow_credentials:
                if _item_allow_credentials:
                    _items.append(_item_allow_credentials.to_dict())
            _dict['allowCredentials'] = _items
        # override the default output from pydantic by calling `to_dict()` of extensions
        if self.extensions:
            _dict['extensions'] = self.extensions.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateWebAuthnAuthenticationVerification200ResponseAuthenticationOptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "challenge": obj.get("challenge"),
            "timeout": obj.get("timeout"),
            "rpId": obj.get("rpId"),
            "allowCredentials": [CreateWebAuthnRegistrationVerification200ResponseRegistrationOptionsExcludeCredentialsInner.from_dict(_item) for _item in obj["allowCredentials"]] if obj.get("allowCredentials") is not None else None,
            "userVerification": obj.get("userVerification"),
            "extensions": CreateWebAuthnRegistrationVerification200ResponseRegistrationOptionsExtensions.from_dict(obj["extensions"]) if obj.get("extensions") is not None else None
        })
        return _obj


