# coding: utf-8

"""
    Python SDK for Logto API

    Python SDK for Logto API.  Note: This SDK is for Logto Cloud and OSS. However, if you are using Logto OSS, some features available in the SDK may not work for you. Please refer to the response of `/api/swagger.json` endpoint on your Logto OSS instance for features available to you.

    The version of the OpenAPI document: 1.22.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class ListApplications200ResponseInnerCustomClientMetadata(BaseModel):
    """
    ListApplications200ResponseInnerCustomClientMetadata
    """ # noqa: E501
    cors_allowed_origins: Optional[List[Annotated[str, Field(min_length=1, strict=True)]]] = Field(default=None, alias="corsAllowedOrigins")
    id_token_ttl: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="idTokenTtl")
    refresh_token_ttl: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="refreshTokenTtl")
    refresh_token_ttl_in_days: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="refreshTokenTtlInDays")
    tenant_id: Optional[StrictStr] = Field(default=None, alias="tenantId")
    always_issue_refresh_token: Optional[StrictBool] = Field(default=None, alias="alwaysIssueRefreshToken")
    rotate_refresh_token: Optional[StrictBool] = Field(default=None, alias="rotateRefreshToken")
    __properties: ClassVar[List[str]] = ["corsAllowedOrigins", "idTokenTtl", "refreshTokenTtl", "refreshTokenTtlInDays", "tenantId", "alwaysIssueRefreshToken", "rotateRefreshToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListApplications200ResponseInnerCustomClientMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListApplications200ResponseInnerCustomClientMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "corsAllowedOrigins": obj.get("corsAllowedOrigins"),
            "idTokenTtl": obj.get("idTokenTtl"),
            "refreshTokenTtl": obj.get("refreshTokenTtl"),
            "refreshTokenTtlInDays": obj.get("refreshTokenTtlInDays"),
            "tenantId": obj.get("tenantId"),
            "alwaysIssueRefreshToken": obj.get("alwaysIssueRefreshToken"),
            "rotateRefreshToken": obj.get("rotateRefreshToken")
        })
        return _obj


