# coding: utf-8

"""
    Python SDK for Logto API

    Python SDK for Logto API.  Note: This SDK is for Logto Cloud and OSS. However, if you are using Logto OSS, some features available in the SDK may not work for you. Please refer to the response of `/api/swagger.json` endpoint on your Logto OSS instance for features available to you.

    The version of the OpenAPI document: 1.22.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from py_logto.models.get_application_sign_in_experience200_response_color import GetApplicationSignInExperience200ResponseColor
from py_logto.models.list_application_organizations200_response_inner_branding import ListApplicationOrganizations200ResponseInnerBranding
from py_logto.models.replace_application_sign_in_experience_request_terms_of_use_url import ReplaceApplicationSignInExperienceRequestTermsOfUseUrl
from typing import Optional, Set
from typing_extensions import Self

class ReplaceApplicationSignInExperienceRequest(BaseModel):
    """
    ReplaceApplicationSignInExperienceRequest
    """ # noqa: E501
    color: Optional[GetApplicationSignInExperience200ResponseColor] = None
    branding: Optional[ListApplicationOrganizations200ResponseInnerBranding] = None
    display_name: Optional[Annotated[str, Field(strict=True, max_length=256)]] = Field(default=None, alias="displayName")
    terms_of_use_url: ReplaceApplicationSignInExperienceRequestTermsOfUseUrl = Field(alias="termsOfUseUrl")
    privacy_policy_url: ReplaceApplicationSignInExperienceRequestTermsOfUseUrl = Field(alias="privacyPolicyUrl")
    __properties: ClassVar[List[str]] = ["color", "branding", "displayName", "termsOfUseUrl", "privacyPolicyUrl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReplaceApplicationSignInExperienceRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of color
        if self.color:
            _dict['color'] = self.color.to_dict()
        # override the default output from pydantic by calling `to_dict()` of branding
        if self.branding:
            _dict['branding'] = self.branding.to_dict()
        # override the default output from pydantic by calling `to_dict()` of terms_of_use_url
        if self.terms_of_use_url:
            _dict['termsOfUseUrl'] = self.terms_of_use_url.to_dict()
        # override the default output from pydantic by calling `to_dict()` of privacy_policy_url
        if self.privacy_policy_url:
            _dict['privacyPolicyUrl'] = self.privacy_policy_url.to_dict()
        # set to None if display_name (nullable) is None
        # and model_fields_set contains the field
        if self.display_name is None and "display_name" in self.model_fields_set:
            _dict['displayName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReplaceApplicationSignInExperienceRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "color": GetApplicationSignInExperience200ResponseColor.from_dict(obj["color"]) if obj.get("color") is not None else None,
            "branding": ListApplicationOrganizations200ResponseInnerBranding.from_dict(obj["branding"]) if obj.get("branding") is not None else None,
            "displayName": obj.get("displayName"),
            "termsOfUseUrl": ReplaceApplicationSignInExperienceRequestTermsOfUseUrl.from_dict(obj["termsOfUseUrl"]) if obj.get("termsOfUseUrl") is not None else None,
            "privacyPolicyUrl": ReplaceApplicationSignInExperienceRequestTermsOfUseUrl.from_dict(obj["privacyPolicyUrl"]) if obj.get("privacyPolicyUrl") is not None else None
        })
        return _obj


