# coding: utf-8

"""
    Python SDK for Logto API

    Python SDK for Logto API.  Note: This SDK is for Logto Cloud and OSS. However, if you are using Logto OSS, some features available in the SDK may not work for you. Please refer to the response of `/api/swagger.json` endpoint on your Logto OSS instance for features available to you.

    The version of the OpenAPI document: 1.22.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_logto.models.update_other_profile_request_address import UpdateOtherProfileRequestAddress
from typing import Optional, Set
from typing_extensions import Self

class UpdateOtherProfileRequest(BaseModel):
    """
    UpdateOtherProfileRequest
    """ # noqa: E501
    family_name: Optional[StrictStr] = Field(default=None, description="The new family name for the user.", alias="familyName")
    given_name: Optional[StrictStr] = Field(default=None, description="The new given name for the user.", alias="givenName")
    middle_name: Optional[StrictStr] = Field(default=None, description="The new middle name for the user.", alias="middleName")
    nickname: Optional[StrictStr] = Field(default=None, description="The new nickname for the user.")
    preferred_username: Optional[StrictStr] = Field(default=None, description="The new preferred username for the user.", alias="preferredUsername")
    profile: Optional[StrictStr] = Field(default=None, description="The new profile for the user.")
    website: Optional[StrictStr] = Field(default=None, description="The new website for the user.")
    gender: Optional[StrictStr] = Field(default=None, description="The new gender for the user.")
    birthdate: Optional[StrictStr] = Field(default=None, description="The new birthdate for the user.")
    zoneinfo: Optional[StrictStr] = Field(default=None, description="The new zoneinfo for the user.")
    locale: Optional[StrictStr] = Field(default=None, description="The new locale for the user.")
    address: Optional[UpdateOtherProfileRequestAddress] = None
    __properties: ClassVar[List[str]] = ["familyName", "givenName", "middleName", "nickname", "preferredUsername", "profile", "website", "gender", "birthdate", "zoneinfo", "locale", "address"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateOtherProfileRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict['address'] = self.address.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateOtherProfileRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "familyName": obj.get("familyName"),
            "givenName": obj.get("givenName"),
            "middleName": obj.get("middleName"),
            "nickname": obj.get("nickname"),
            "preferredUsername": obj.get("preferredUsername"),
            "profile": obj.get("profile"),
            "website": obj.get("website"),
            "gender": obj.get("gender"),
            "birthdate": obj.get("birthdate"),
            "zoneinfo": obj.get("zoneinfo"),
            "locale": obj.get("locale"),
            "address": UpdateOtherProfileRequestAddress.from_dict(obj["address"]) if obj.get("address") is not None else None
        })
        return _obj


